/*
 * Copyright 2008- kensir0u.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
/*
 * 쐬       F2008/11/05
 * pbP[W   Fikdnet.dijava
 * t@C   FInvokerUtil.java
 */
package ikdnet.dijava;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

/**
 * <i>Tv</i>F Invoke[eBeB[ NX@.
 * <p>
 * Invoke[eBeB[ NX
 * 
 * 
 * @author kensir0u
 * @version 1.0
 * @since JDK 5.0
 * 
 */
public class InvokerUtil {

	/**
	 * 
	 * <i>Tv</i>F \bhsB
	 * .<p>
	 * \bhsB
	 *@
	 * @param src
	 * @param command
	 * @return@sʃIuWFNg
	 * @throws Exception
	 */
	public static Object invoke(Map<?,?> src, String command) throws Exception {

		StringTokenizer commands = new StringTokenizer(command);

		List<String> a = new ArrayList<String>();

		if (commands.countTokens() == 1) {

			Set<?> s = src.keySet();
			String key = (String) s.iterator().next();
			Object o = src.get(key);
			JavaSource js = (JavaSource) o;
			Class<?> c = js.getC();
			Method m = c.getMethod("main", String[].class);
			// mainT
			if (m != null) {
				m.invoke(null, new Object[] { null });
			} else {
				System.out.println("No such Method [main]");
			}
			// Ȃ΃G[
			return null;
		} else if (commands.countTokens() == 2) {
			Set<?> s = src.keySet();
			String key = (String) s.iterator().next();
			Object o = src.get(key);
			JavaSource js = (JavaSource) o;
			Class<?> c = js.getC();
			commands.nextToken();
			String methodname = commands.nextToken();
			Method m = c.getMethod(methodname);
			if (m != null) {
				return m.invoke(c.newInstance());
			} else {
				System.out.println("No such Method [" + methodname + "]");
			}
			return null;

		} else {
			Set<?> s = src.keySet();
			String key = (String) s.iterator().next();
			Object o = src.get(key);
			JavaSource js = (JavaSource) o;
			Class<?> c = js.getC();
			commands.nextToken();
			String methodname = commands.nextToken();

			while (commands.hasMoreTokens()) {
				a.add(commands.nextToken());
			}

			//String[] args = (String[]) a.toArray(new String[0]);

			Method[] ms = c.getDeclaredMethods();
			List<Method> me = new ArrayList<Method>();
			for (int i = 0; i < ms.length; i++) {
				String method = ms[i].getName();
				if (methodname.equals(method)) {
					me.add(ms[i]);
				}
			}

			if (me.size() == 0) {
				System.out.println("No such Method [" + methodname + "]");
			} else if (me.size() == 1) {
				Method m = me.get(0);
				Class<?> cp[] = m.getParameterTypes();

				if (cp == null || cp.length == 0) {
					return m.invoke(c.newInstance());
				} else {
					System.out.println("Not implement yet.");
				}
			} else {
				System.out.println("Not implement yet.");
			}

		}

		return null;
	}
}
