/*
 * Copyright 2008- kensir0u.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
/*
 * 쐬       F2008/11/05
 * pbP[W   Fikdnet.dijava
 * t@C   FJavaMemoryObject.java
 */
package ikdnet.dijava;

import java.io.IOException;
import java.net.URI;

import javax.tools.JavaFileObject;
import javax.tools.SimpleJavaFileObject;

/**
 * <i>Tv</i>F [ɕێt@CIuWFNgNX
 *@.<p>
 * [ɕێt@CIuWFNgNX
 * 
 *
 * @author  kensir0u
 * @version 1.0
 * @since   JDK 5.0
 *
 */
public class JavaMemoryObject extends SimpleJavaFileObject{
	
	/**
	 * <i>Tv</i>F \[X
	 * .<p>
	 * \[X
	 *
	 */
	private String source = "";
	
	/**
	 * 
	 * <i>Tv</i>F t@CzpXƃ\[Xݒ
	 * .<p>
	 * t@CzpXƃ\[Xݒ
	 *@
	 * @param uri
	 * @param source
	 */
	protected JavaMemoryObject(URI uri,String source) {
		super(uri,JavaFileObject.Kind.SOURCE);
		this.source = source;
	}
	
	@Override
	public CharSequence getCharContent(boolean ignoreEncodingErrors) throws IOException, IllegalStateException,UnsupportedOperationException {
		return source;
	}

}