/*
 * Copyright 2008- kensir0u.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
/*
 * 쐬       F2008/11/05
 * pbP[W   Fikdnet.dijava
 * t@C   FJavaSource.java
 */
package ikdnet.dijava;

import java.lang.reflect.Method;
import java.util.List;

/**
 * <i>Tv</i>F Java\[X킷NX @.
 * <p>
 * Java\[X킷NX
 * 
 * 
 * @author kensir0u
 * @version 1.0
 * @since JDK 5.0
 * 
 */
public class JavaSource {

	/**
	 * <i>Tv</i>F \[XXg .
	 * <p>
	 * \[XXg
	 * 
	 */
	private List<String> source;
	/**
	 * <i>Tv</i>F IvVXg .
	 * <p>
	 * IvVXg
	 * 
	 */
	private List<?> option;
	/**
	 * <i>Tv</i>F pbP[W .
	 * <p>
	 * pbP[W
	 * 
	 */
	private String package_name;
	/**
	 * <i>Tv</i>F t@C .
	 * <p>
	 * t@C
	 * 
	 */
	private String file_name;
	/**
	 * <i>Tv</i>F \bhz .
	 * <p>
	 * \bhz
	 * 
	 */
	private Method[] ms;
	/**
	 * <i>Tv</i>F NX .
	 * <p>
	 * NX
	 * 
	 */
	private Class<?> c;
	/**
	 * <i>Tv</i>F CtO .
	 * <p>
	 * CtO
	 * 
	 */
	private boolean mainflg;
	/**
	 * <i>Tv</i>F ύX\tO .
	 * <p>
	 * ύX\tO
	 * 
	 */
	private boolean editable;

	/**
	 * 
	 * <i>Tv</i>F \[XApbP[ẂAt@ĆAIvV̏Zbg .
	 * <p>
	 * \[XApbP[ẂAt@ĆAIvV̏Zbg @
	 * 
	 * @param source
	 * @param package_name
	 * @param file_name
	 * @param option
	 */
	public JavaSource(final List<String> source, final String package_name, final String file_name,
			final List<?> option) {
		this.source = source;
		this.package_name = package_name;
		this.file_name = file_name;
		this.option = option;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#source}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#source}ԋpB @
	 * 
	 * @return the source
	 */
	public List<String> getSource() {
		return source;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#source}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#source}ݒ肷B
	 * 
	 * @param source
	 *            the source to set
	 */
	public void setSource(final List<String> source) {
		this.source = source;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#option}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#option}ԋpB @
	 * 
	 * @return the option
	 */
	public List<?> getOption() {
		return option;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#option}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#option}ݒ肷B
	 * 
	 * @param option
	 *            the option to set
	 */
	public void setOption(final List<?> option) {
		this.option = option;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#package_name}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#package_name}ԋpB @
	 * 
	 * @return the package_name
	 */
	public String getPackage_name() {
		return package_name;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#package_name}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#package_name}ݒ肷B
	 * 
	 * @param package_name
	 *            the package_name to set
	 */
	public void setPackage_name(final String package_name) {
		this.package_name = package_name;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#file_name}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#file_name}ԋpB @
	 * 
	 * @return the file_name
	 */
	public String getFile_name() {
		return file_name;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#file_name}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#file_name}ݒ肷B
	 * 
	 * @param file_name
	 *            the file_name to set
	 */
	public void setFile_name(final String file_name) {
		this.file_name = file_name;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#ms}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#ms}ԋpB @
	 * 
	 * @return the ms
	 */
	public Method[] getMs() {
		return ms;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#ms}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#ms}ݒ肷B
	 * 
	 * @param ms
	 *            the ms to set
	 */
	public void setMs(final Method[] ms) {
		this.ms = ms;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#c}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#c}ԋpB @
	 * 
	 * @return the c
	 */
	public Class<?> getC() {
		return c;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#c}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#c}ݒ肷B
	 * 
	 * @param c
	 *            the c to set
	 */
	public void setC(final Class<?> c) {
		this.c = c;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#mainflg}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#mainflg}ԋpB @
	 * 
	 * @return the mainflg
	 */
	public boolean isMainflg() {
		return mainflg;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#mainflg}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#mainflg}ݒ肷B
	 * 
	 * @param mainflg
	 *            the mainflg to set
	 */
	public void setMainflg(final boolean mainflg) {
		this.mainflg = mainflg;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.JavaSource#editable}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#editable}ԋpB @
	 * 
	 * @return the editable
	 */
	public boolean isEditable() {
		return editable;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.JavaSource#editable}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.JavaSource#editable}ݒ肷B
	 * 
	 * @param editable
	 *            the editable to set
	 */
	public void setEditable(final boolean editable) {
		this.editable = editable;
	}

}
